/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.field.shape;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import net.miginfocom.swing.MigLayout;
import org.openide.util.NbBundle;

/**
 *
 * @author johan
 */
@NbBundle.Messages({"ShapePropertyMappingVisualPanel1.saveToRegistryCheckBox.text=Save mapping to registry"})
public final class ShapePropertyMappingVisualPanel1 extends JPanel {
    
    public static final String PROP_COMBOBOX_MAPPING_VALUE = "valueMappingBox";
    
    private final ShapePropertyMappingFormRow valueRow = ShapePropertyMappingFormRow.createValueRow(true);
    private final JCheckBox saveToRegistryCheckBox = new JCheckBox();
    
    /**
     * Creates new form ShapePropertyMappingVisualPanel1
     */
    public ShapePropertyMappingVisualPanel1() {
        initComponents();
    }
    
    @Override
    public String getName() {
        return "Step #1"; // not used because this panel will be wrapped in an ASBodyPanel
    }

    public JCheckBox getSaveToRegistryCheckBox() {
        return saveToRegistryCheckBox;
    }

    public ShapePropertyMappingFormRow getValueMappingFormRow() {
        return valueRow;
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     */
    @SuppressWarnings("unchecked")
    private void initComponents() {
        setLayout(new MigLayout("wrap 1, insets 0 8 0 0"));
        setBackground(Color.white);
        saveToRegistryCheckBox.setBackground(Color.white);
        saveToRegistryCheckBox.setText(Bundle.ShapePropertyMappingVisualPanel1_saveToRegistryCheckBox_text());
        add(valueRow);
        add(saveToRegistryCheckBox);
        
        valueRow.getPropertiesComboBox().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                firePropertyChange(PROP_COMBOBOX_MAPPING_VALUE, null, valueRow.getSelectedProperty());
            }
        });
    }
}
